#
# Register usage:
#    $8: temporary holding the shifted value
#   $10: floor(log(N)) result

.data
N:     .word  63

.text
	.global main
main:
	# this loads the value of memory location 'N' into $8
	lw	$8, N($gp)
	
	# initialize (floor(log(1)) = 0, and N is positive by problem definition
	or	$10, $0, $0

	# the following is like a while loop:
	#  - test is at the top
	#  - unconditional branch back at the bottom
looptop:
	beq	$8, $0, done
	addi 	$10, $10, 1
	srl	$8, $8, 1
	j	looptop

done:
	addi	$10, $10, -1
	jr	$ra
	